Subject: Re: [PATCH 1/2] Add infrastructure for translating Git with gettext

From: Thomas Rast <[email-masked]>
Date: Mon, 14 Jun 2010 23:56:46 +0200

Ævar Arnfjörð Bjarmason wrote:
> It turns out that this doesn't actually work, and I can't find a
> workaround. In Bash and Solaris's /bin/sh this executes until "dies
> here". The problem is that I can't use the subshell trick, since the
> gettext.sh inclusion has to be done in the current shell (I checked,
> tests will fail).
> 
>     #!/bin/sh
>     (. does-not-exist.sh)
>     echo "A subshell made it! ret = $?"
>     . does-not-exist.sh
>   # dies here
>     echo "A real shell made it! ret = $?"
> 
> Is there some clever shellscript trick that I'm missing, or will I
> have to resort to modifying the file at `make' time for this to work
> everywhere?

Works for me in bash (4.0.35), but fails the way you say in dash (if
only I could figure out the option that tells me the version!).

This works however:

  type does-not-exist.sh 2>/dev/null && . does-not-exist.sh

I suspect it only works if the script is executable, as otherwise type
would not find it (but . would).  But at least on my system, it is.

-- 
Thomas Rast
trast@{inf,student}.ethz.ch